
/*
Copyright 2007-2008 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function YaripPage(id, name, whitelist, blacklist, styles, extension)
{
	this.id = null;
	this.name = "";
	this.whitelist = whitelist ? whitelist : new YaripWhitelist();
	this.blacklist = blacklist ? blacklist : new YaripBlacklist();
	this.styles = styles ? styles : new YaripStylesList();
	this.extension = extension ? extension : new YaripExtList();

	this.setId = function(id)
	{
		if (id) this.id = "" + id;
		else this.id = yarip.getId();
	}

	this.getId = function()
	{
		return this.id;
	}

	this.setName = function(name)
	{
		if (name) this.name = "" + name;
	}

	this.getName = function()
	{
		return this.name;
	}

	this.clone = function(purge)
	{
		var tmp = new this.constructor(null, this.name, this.whitelist.clone(purge), this.blacklist.clone(purge), this.styles.clone(), this.extension.clone());
		for (var k in this) if(this[k] && typeof(this[k]) != "object" && !k.match(/id|name/)) tmp[k] = this[k];
		return tmp;
	}

	this.generateXml = function()
	{
		var tmp =
			this.whitelist.generateXml() +
			this.blacklist.generateXml() +
			this.styles.generateXml() +
			this.extension.generateXml();
		if (tmp != "") return "\t<page id=\"" + this.id + "\" name=\"" + this.name + "\">\n" + tmp + "\t</page>\n";
		else return "";
	}

	this.generateCSS = function()
	{
		var tmp =
			this.blacklist.generateCSS() +
			this.styles.generateCSS();
		if (tmp != "")
		{
			var mozDoc = "@-moz-document ";
			if (this.name.match(yarip.domainRegExp)) mozDoc += "domain";
			else if (this.name.match(yarip.uriRegExp)) mozDoc += "url-prefix";
			else return "";
			mozDoc += "(" + this.name + ")\n";
			return mozDoc + "{\n" + tmp + "}\n\n";
		}
		else return "";
	}

	this.setId(id);
	this.setName(name);
}
